svn commit: r269715 - user/pho/stress2/misc

Peter Holm pho at FreeBSD.org
Fri Aug 8 13:37:32 UTC 2014


Author: pho
Date: Fri Aug  8 13:37:31 2014
New Revision: 269715
URL: http://svnweb.freebsd.org/changeset/base/269715

Log:
  Added a new nullfs test scenario.
  
  Sponsored by:	 EMC / Isilon storage division

Added:
  user/pho/stress2/misc/crossmp4.sh   (contents, props changed)

Added: user/pho/stress2/misc/crossmp4.sh
==============================================================================
--- /dev/null	00:00:00 1970	(empty, because file is newly added)
+++ user/pho/stress2/misc/crossmp4.sh	Fri Aug  8 13:37:31 2014	(r269715)
@@ -0,0 +1,107 @@
+#!/bin/sh
+
+#
+# Copyright (c) 2014 EMC Corp.
+# All rights reserved.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+# $FreeBSD$
+#
+
+# Parallel mount and umount of file systems
+# "panic: Lock (lockmgr) null not locked @ kern/vfs_default.c:523." seen.
+# http://people.freebsd.org/~pho/stress/log/kostik698.txt
+# Fixed by r269708.
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+
+. ../default.cfg
+
+N=`sysctl -n hw.ncpu`
+size=$((`sysctl -n hw.usermem` / 1024 / 1024))
+
+mounts=$N		# Number of parallel scripts
+
+if [ $# -eq 0 ]; then
+	mount | grep "$mntpoint" | grep -q md && umount ${mntpoint}
+	mdconfig -l | grep -q md$mdstart &&  mdconfig -d -u $mdstart
+
+	mdconfig -a -t swap -s ${size}m -u $mdstart
+	bsdlabel -w md$mdstart auto
+	newfs $newfs_flags md${mdstart}$part > /dev/null 2>&1
+	mount /dev/md${mdstart}$part $mntpoint
+
+	# start the parallel tests
+	for i in `jot $mounts`; do
+		m=$(( i + mdstart - 1 ))
+		./$0 $m &
+		./$0 find &
+	done
+
+	for i in `jot $mounts`; do
+		wait; wait
+	done
+
+	for i in `jot $mounts`; do
+		rm -f $D$m
+	done
+	while mount | grep -q "on $mntpoint "; do
+		umount $mntpoint > /dev/null 2>&1 || sleep 1
+	done
+	mdconfig -d -u $mdstart
+
+else
+	touch /tmp/crossmp.continue
+	if [ $1 = find ]; then
+		while [ -f /tmp/crossmp.continue ]; do
+			find ${mntpoint}* -type f > /dev/null 2>&1
+		done
+	else
+		m=$1
+		set `df -ik $mntpoint | tail -1 | awk '{print $4,$7}'`
+		export KBLOCKS=$(($1 / N))
+		export INODES=$(($2 / N))
+		export runRUNTIME=1m
+		export INCARNATIONS=4
+		# The test: Parallel mount and unmounts
+		for i in `jot 4`; do
+			[ ! -d ${mntpoint}$m ] && mkdir ${mntpoint}$m
+			mount -t nullfs $mntpoint ${mntpoint}$m
+			mkdir -p ${mntpoint}$m/$m
+			chmod 777 ${mntpoint}$m/$m
+			export RUNDIR=${mntpoint}$m/$m/stressX
+			export CTRLDIR=${mntpoint}$m/$m/stressX.control
+			(cd  ${mntpoint}$m/$m && find . -delete)
+			su $testuser -c 'cd ..; ./run.sh disk.cfg' > \
+			    /dev/null 2>&1 &
+			sleep 30
+
+			while mount | grep -q "on ${mntpoint}$m "; do
+				opt=$([ $((`date '+%s'` % 2)) -eq 0 ] && echo "-f")
+				umount $opt ${mntpoint}$m > /dev/null 2>&1
+			done
+			wait
+		done
+		rm -f /tmp/crossmp.continue
+	fi
+fi


More information about the svn-src-user mailing list